var qm = require('qminer');
var loader = require('qminer-data-loader');
'libraries loaded';

var base = new qm.Base({
  mode: 'createClean',
  schema: [{
    name: 'Visitors',
    fields: [{ name: 'ID', type: 'string' }],
    joins: [{ name: 'lectures', type: 'index', store: 'Lectures', inverse : 'visitors' }]
  }, {
    name: 'Lectures',
    fields: [{ name: 'Title', type: 'string' }],
    joins: [{ name: 'visitors', type: 'index', store: 'Visitors', inverse: 'lectures'}]
  }]
});
'defined schema';

visitors.loadJson('visits.json', 1000);
'Loaded' + visitors.length + 'visitors and' + lectures.length + 'lectures';

var john = base.store('Visitors')[id];
john.ID + ' viewed ' + john.lectures.length + ' lectures';

john.lectures.each(function (l) { console.log(' -', l.Title); });;

var coVisitors = visitor.lectures.join('visitors');
coVisitors.length + ' visitors watched at least one of the same lectures';

var coLectures = coVisitors.join('lectures', 100);
'Co-visitors watched ' + coLectures.length + ' lectures';

var result = coLectures.setDiff(visitor.lectures);
result.sortByFq(-1).trunc(5);;

result.each(function (l) { console.log(' -', l.Title); });;